#include "generic.h"
// #include "getopt.h"
// #include <sys/timeb.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

inline void SetPixelColor(SDL_Surface *screen, int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
  ((unsigned char*)(screen->pixels))[x*3+0 + y*screen->pitch] = red;
  ((unsigned char*)(screen->pixels))[x*3+1 + y*screen->pitch] = green;
  ((unsigned char*)(screen->pixels))[x*3+2 + y*screen->pitch] = blue;
} // SetPixelColor

inline void SetPixel(SDL_Surface* screen, int x, int y)
{
  SetPixelColor(screen, x, y, 255, 255, 255);
} // SetPixel

inline void swap(int &a, int &b)
{
  int t;

  t = a;
  a = b;
  b = t;
} // swap

int min(int a, int b)
{
  if(a < b) return a;
  else return b;
} // min

int main(int argc, char** argv)
{
    SDL_Surface      *screen, *backup_screen;
    SDL_Event        event;
    SDL_Rect         dst_rect, full_image_rect, scrolled_rect, location;
    int              window_width, window_height, thumb_height, thumb_border_size;
    long pixel_set = 0;

    window_width = 512; window_height = 512;

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {
	cerr << "Could not initialize SDL video" << endl;
	exit(-1);
    } // if
    atexit(SDL_Quit);

    Uint32 flags = 0;

    // flags |= SDL_FULLSCREEN;

    screen = SDL_SetVideoMode(window_width, window_height, 24, flags);

    if(!screen) {
	cerr << "could not SetVideoMode() - abort" << endl;
	exit(-1);
    } // if

    int yA, x0A, y0A, x1A, y1A, delta_xA, delta_yA, distA, incEA, incNEA;
    int yB, x0B, y0B, x1B, y1B, delta_xB, delta_yB, distB, incEB, incNEB;

    const int NO_LINES = 200*1000;

    for(int iter = 0; iter < NO_LINES; iter++) {

      x0A = 10; y0A = 10;
      x1A = 310; y1A = 270;

      x0B = 50; y0B = 90;
      x1B = 210; y1B = 170;
      
      delta_xA = x1A-x0A;
      delta_yA = y1A-y0A;

      delta_xB = x1B-x0B;
      delta_yB = y1B-y0B;
      
      distA = 2*delta_yA - delta_xA;
      distB = 2*delta_yB - delta_xB;
      
      incEA = 2*delta_yA;
      incNEA = 2*(delta_yA-delta_xA);
      incEB = 2*delta_yB;
      incNEB = 2*(delta_yB-delta_xB);
  
      SetPixel(screen, x0A, y0A);
      pixel_set++;
      SetPixel(screen, x0B, y0B);
      pixel_set++;

      int lengthA = x1A-x0A;      
      int xA = x0A;
      yA = y0A;

      int lengthB = x1B-x0B;
      int xB = x0B;
      yB = y0B;

      long x, y;

      x = xA | ((long)xB << 16);
      y = yA | ((long)yB << 16);

      for(int i = 0; i < min(lengthA,lengthB); i++) {

	if(distA < 0) distA += incEA;
	else {
	  distA += incNEA;
	  y++;
	} // else
	
	if(distB < 0) distB += incEB;
	else {
	  distB += incNEB;
	  y += 1L << 16;
	} // else

	x += (1 | (1L << 16));
	
      	SetPixel(screen, x & 0xFFFF, y & 0xFFFF);
	pixel_set++;
      	SetPixel(screen, x >> 16, y >> 16);
	pixel_set++;
      } // for

      // draw rest of line

      if(lengthA > lengthB) {
	
	for(int i = x & 0xFFFF; i <= x1A; i++) {
	  
	  if(distA < 0) distA += incEA;
	  else {
	    distA += incNEA;
	    y++;
	  } // else
	  
	  SetPixel(screen, i, y & 0xFFFF);
	  pixel_set++;
	} // for
      } // if
      else {
	
	// draw rest of line B

	y >>= 16;
	
	for(int i = x >> 16; i <= x1B; i++) {
	  
	  if(distB < 0) distB += incEB;
	  else {
	    distB += incNEB;
	    y++;
	  } // else
	  
	  SetPixel(screen, i, y);
	  pixel_set++;
	} // for
      } // else 
     
    } // for

    cout << "no pixels set: " << pixel_set << endl;

    goto exit_app;

    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen, 0, 0, window_width, window_height);
    SDL_LockSurface(screen);

    for(;;) {

	if((SDL_PollEvent(&event) == 0) && (event.type == SDL_KEYDOWN)) 
	    goto exit_app;

	switch(event.type) {
		
	    case SDL_MOUSEMOTION:	      
		break;
		
	    case SDL_MOUSEBUTTONDOWN:
		break;
		
	    case SDL_MOUSEBUTTONUP:
		break;
		
	    case SDL_KEYDOWN:
		
		switch(event.key.keysym.sym) {
		    
		    case 27:
		    case 'q':
		    case 'Q':
			goto exit_app;
			
		    default:
			break;
		} // switch
	} // switch

    } // for
	    
 exit_app:

    SDL_UnlockSurface(screen);	    
    SDL_FreeSurface(screen);

    exit(0);
} // main
