#include "generic.h"
// #include "getopt.h"
// #include <sys/timeb.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

inline void SetPixelColor(SDL_Surface *screen, int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
  ((unsigned char*)(screen->pixels))[x*3+0 + y*screen->pitch] = red;
  ((unsigned char*)(screen->pixels))[x*3+1 + y*screen->pitch] = green;
  ((unsigned char*)(screen->pixels))[x*3+2 + y*screen->pitch] = blue;
} // SetPixelColor

inline void SetPixel(SDL_Surface* screen, int x, int y)
{
  SetPixelColor(screen, x, y, 255, 255, 255);
} // SetPixel

inline void swap(int &a, int &b)
{
  int t;

  t = a;
  a = b;
  b = t;
} // swap

int main(int argc, char** argv)
{
    SDL_Surface      *screen, *backup_screen;
    SDL_Event        event;
    SDL_Rect         dst_rect, full_image_rect, scrolled_rect, location;
    int              window_width, window_height, thumb_height, thumb_border_size;
    int              pixel_set = 0;

    window_width = 512; window_height = 512;

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {
	cerr << "Could not initialize SDL video" << endl;
	exit(-1);
    } // if
    atexit(SDL_Quit);

    Uint32 flags = 0;

    // flags |= SDL_FULLSCREEN;

    screen = SDL_SetVideoMode(window_width, window_height, 24, flags);

    if(!screen) {
	cerr << "could not SetVideoMode() - abort" << endl;
	exit(-1);
    } // if

    int x0, y0, x1, y1, delta_x, delta_y, dist, incE, incNE;
    register int value;
    
    const int NO_LINES = 200*1000;

    for(int i = 0; i < NO_LINES; i++) {

      x0 = 10; y0 = 10;
      x1 = 310; y1 = 270;

      delta_x = x1-x0;
      delta_y = y1-y0;
      
      dist = 2*delta_y - delta_x;
      
      incE = 2*delta_y;
      incNE = 2*(delta_y-delta_x);

      value = y0 << 16 | dist;
      
      SetPixel(screen, x0, y0);
      pixel_set++;
      
      for(int x = x0; x <= x1; x++) {
	if((value & 0xFFFF) < 0) value += incE;
	else value += incNE | (1 << 16);
	
     	SetPixel(screen, x, value >> 16);
	pixel_set++;
      } // while
    } // for

    cout << "no pixels set: " << pixel_set << endl;

    goto exit_app;

    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen, 0, 0, window_width, window_height);
    SDL_LockSurface(screen);

    for(;;) {

	if((SDL_PollEvent(&event) == 0) && (event.type == SDL_KEYDOWN)) 
	    goto exit_app;

	switch(event.type) {
		
	    case SDL_MOUSEMOTION:	      
		break;
		
	    case SDL_MOUSEBUTTONDOWN:
		break;
		
	    case SDL_MOUSEBUTTONUP:
		break;
		
	    case SDL_KEYDOWN:
		
		switch(event.key.keysym.sym) {
		    
		    case 27:
		    case 'q':
		    case 'Q':
			goto exit_app;
			
		    default:
			break;
		} // switch
	} // switch

    } // for
	    
 exit_app:

    SDL_UnlockSurface(screen);	    
    SDL_FreeSurface(screen);

    exit(0);
} // main
